#include "../../crypto_aead.h"
#include "../../dll.h"

#include <string.h>
#include "Ketje.h"
#include <stdio.h>

EXPORT int crypto_aead_encrypt(
    unsigned char *c,unsigned long long *clen,
    const unsigned char *m,unsigned long long mlen,
    const unsigned char *ad,unsigned long long adlen,
    const unsigned char *nsec,
    const unsigned char *npub,
    const unsigned char *k
    )
{
  #if DBG
    FILE *fp = stdout;
    displaySetLevel(3);
    displaySetIntermediateValueFile(fp);
    
    int i;
    printf("MLEN : %d\n", mlen);
    printf("A: ");
    for (i=0 ; i < adlen; i++) printf("%02X", ad[i]);
    printf("\n");
    printf("M: ");
    for (i=0 ; i < mlen; i++) printf("%02X", m[i]);
    printf("\n");
  #endif

    Ketje_Instance instance;  
displayStateAsLanes(0, "Beginning", (&instance)->state);    
    Ketje_Initialize(&instance, k, 128, npub, 128);
displayStateAsLanes(0, "After initialize", (&instance)->state);
    Ketje_FeedAssociatedData(&instance, ad, adlen);
    Ketje_WrapPlaintext(&instance, m, c, mlen);
    *clen = mlen;
    Ketje_GetTag(&instance, c+mlen, 12);
    *clen += 12;

    
    return 0;
}

EXPORT int crypto_aead_decrypt(
    unsigned char *m,unsigned long long *mlen,
    unsigned char *nsec,
    const unsigned char *c,unsigned long long clen,
    const unsigned char *ad,unsigned long long adlen,
    const unsigned char *npub,
    const unsigned char *k
    )
{
    Ketje_Instance instance;
    unsigned char tag[12];

    if (clen < 12)
        return -1;

    Ketje_Initialize(&instance, k, 128, npub, 128);
    Ketje_FeedAssociatedData(&instance, ad, adlen);
    *mlen = clen-12;
    Ketje_UnwrapCiphertext(&instance, c, m, *mlen);
    Ketje_GetTag(&instance, tag, 12);
    if (memcmp(tag, c+(*mlen), 12) != 0) {
        memset(m, 0, *mlen);
        return -1;
    }
    else
        return 0;
}
